use DFA::Cellular;
use Quantum::Superpositions;

my $dfa = DFA::Cellular->new(15,10,<<INIT);
***************
*             *
* **          *
*   *    *    *
*  * *****    *
*      ***    *
*             *
*  * *   **   *
*        *    *
***************
INIT


sub conway {
	my ($neigh) = @_;
	my $me   = $neigh->[1][1] eq '*' ? 1 : 0;
	my $them = grep($_ eq '*',
			@{$neigh->[0]}, @{$neigh->[1]}, @{$neigh->[2]}) 
		 - $me;
	return '*' if $them==2 && $me || $them==3;
	return ' ';
}

my @schroedinger = (' ','*');
sub die {
	return $schroedinger[rand 2] if rand() < 0.95;
	return;
}

$dfa->addrule(
	any (
		DFA::Cellular::ProcRule->new(\&conway),
 	 	DFA::Cellular::ProcRule->new(\&die),
	),
);

$dfa->mapout(sub {eigenstates($_[0])>1 ? '?' : $_[0]});

while (1) {
	$dfa->show;
	$dfa->step;
}
