use DFA::Cellular;
use Quantum::Superpositions;

my $dfa = DFA::Cellular->new(40,20,<<INIT);
****************************************
* 33                                   *
* 2  3 2                               *
* 1               2                    *
*   2                      4           *
* 2   2                2               *
*                                      *
*   3          2    2                  *
*                                      *
*                   2                  *
*          1               4           *
*                                      *
*                                      *
*       1  1     2    4                *
*                                      *
*    1                                 *
*                                      *
* 1                                    *
*    1                                 *
****************************************
INIT

$dfa->show;

$dfa->addrule(
    any(
	DFA::Cellular::Rule->new(['...',
				  '.1.'  => '2',
				  '.*.'
				 ]),
	DFA::Cellular::Rule->new(['1..',
				  '...'  => '1',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.1.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.2*'  => '3',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '2',
				  '2..'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.2.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['.*.',
				  '.3.'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '3',
				  '..3'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.3.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '*4.'  => '1',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['..4',
				  '...'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.4.'  => ' ',
				  '...'
				 ]),
    )
);

$dfa->mapout( sub{my @states = eigenstates($_[0]);
		  @states==0 ? ' ' : @states>1 ? '@' : $_[0]} );


while (1) {
	$dfa->step;
	$dfa->show;
}
