use DFA::Cellular;

my $dfa = DFA::Cellular->new(10,10,<<INIT);
**********
*        *
*        *
*        *
*        *
*        *
*        *
* 1      *
*        *
**********
INIT

$dfa->show;

$dfa->addrule(
	DFA::Cellular::Rule->new(['1..',
				  '...'  => '1',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '1..'  => '2',
				  '.*.'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.1.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '2',
				  '2..'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '..*'  => '3',
				  '.2.'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.2.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '3',
				  '..3'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.3.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['.*.',
				  '..3'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['..4',
				  '...'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.4.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['*4.',
				  '...'  => '1',
				  '...'
				 ]),
);

while (1) {
	$dfa->step;
	$dfa->show;
}
