use DFA::Cellular;

my $dfa = DFA::Cellular->new(11,10,<<INIT);
***********
*  3  3   *
*    3 3  *
*   3 3   *
*      2  *
*     2   *
*      2  *
*11 1     *
*         *
***********
INIT

$dfa->show;

$dfa->addrule(
	DFA::Cellular::Rule->new(['...',
				  '.1.'  => '2',
				  '.*.'
				 ]),
	DFA::Cellular::Rule->new(['1..',
				  '...'  => '1',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.1.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.2*'  => '3',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '2',
				  '2..'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.2.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['.*.',
				  '.3.'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '...'  => '3',
				  '..3'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.3.'  => ' ',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '*4.'  => '1',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['..4',
				  '...'  => '4',
				  '...'
				 ]),
	DFA::Cellular::Rule->new(['...',
				  '.4.'  => ' ',
				  '...'
				 ]),
);

while (1) {
	$dfa->step;
	$dfa->show;
}
