use DFA::Cellular;

my $dfa = DFA::Cellular->new(40,20,<<INIT);
****************************************
* 33                                   *
* 2  3 2                               *
* 1               2                    *
*   2                      4           *
* 2   2                2               *
*                                      *
*   3          2    2                  *
*                                      *
*                   2                  *
*          1               4           *
*                                      *
*                                      *
*       1  1     2    4                *
*                                      *
*    1                                 *
*                                      *
* 1                                    *
*    1                                 *
****************************************
INIT

$dfa->show;

sub next {
	my ($n) = @_;
	my $me   = $n->[1][1];
	if ($me eq '1') {
		return 2 if $n->[2][1] eq '*';
		return 4 if $n->[1][2] eq '*';
		return ' ';
	}
	if ($me eq '2') {
		return 3 if $n->[1][2] eq '*';
		return 1 if $n->[0][1] eq '*';
		return ' ';
	}
	if ($me eq '3') {
		return 4 if $n->[0][1] eq '*';
		return 2 if $n->[1][0] eq '*';
		return ' ';
	}
	if ($me eq '4') {
		return 1 if $n->[1][0] eq '*';
		return 3 if $n->[2][1] eq '*';
		return ' ';
	}
	return 1 if $n->[0][0] eq 1;
	return 2 if $n->[2][0] eq 2;
	return 3 if $n->[2][2] eq 3;
	return 4 if $n->[0][2] eq 4;
	return ' ';
}

$dfa->addrule(
	DFA::Cellular::ProcRule->new(\&next)
);

while (1) {
	$dfa->step;
	$dfa->show;
}
