use DFA::Cellular;

my $dfa = DFA::Cellular->new(40,20,<<INIT);
****************************************
*                                      **
*    **                                **
*     *       *                        **
*       * *****                        **
*           ***                        **
*                                      **
*     * *     **                       **
*             *                        **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*                                      **
*****************************************
 ****************************************
INIT

$dfa->show();

sub conway {
	my ($neigh) = @_;
	my $me   = $neigh->[1][1] eq '*' ? 1 : 0;
	my $them = grep($_ eq '*', @{$neigh->[0]}, @{$neigh->[1]}, @{$neigh->[2]}) 
		 - $me;
	return '*' if $them==2 && $me || $them==3;
	return ' ';
}

sub die {
	my ($neigh) = @_;
	my $me   = $neigh->[1][1] eq '*' ? 1 : 0;
	return $me unless rand() < 0.05;
	return ' ';
}

$dfa->addrule(
	DFA::Cellular::ProcRule->new(\&conway),
);

while (1) {
	$dfa->step;
	$dfa->show;
}
